package cn.ibizlab.businesscentral.core.service.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.service.domain.ContractTemplate;
import cn.ibizlab.businesscentral.core.service.filter.ContractTemplateSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[ContractTemplate] 服务对象接口
 */
public interface IContractTemplateService extends IService<ContractTemplate>{

    boolean create(ContractTemplate et) ;
    void createBatch(List<ContractTemplate> list) ;
    boolean update(ContractTemplate et) ;
    void updateBatch(List<ContractTemplate> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    ContractTemplate get(String key) ;
    ContractTemplate getDraft(ContractTemplate et) ;
    boolean checkKey(ContractTemplate et) ;
    boolean save(ContractTemplate et) ;
    void saveBatch(List<ContractTemplate> list) ;
    Page<ContractTemplate> searchDefault(ContractTemplateSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<ContractTemplate> getContracttemplateByIds(List<String> ids) ;
    List<ContractTemplate> getContracttemplateByEntities(List<ContractTemplate> entities) ;
}


